# https://hub.docker.com/r/library/node/tags/
image: node:lts

# This folder is cached between builds
# http://docs.gitlab.com/ce/ci/yaml/README.html#cache

before_script:
  - apt-get update -qq && apt-get install -y -qq libssl-dev git-crypt
  - node -v
  - npm -v
  - openssl version
  - git-crypt --version
  - openssl base64 -A -d -in "$GIT_CRYPT_KEY_FILE_B64" -out "$(pwd)/key"
  - git-crypt unlock "$(pwd)/key"

stages:
  - prep
  - test
  - build

prep:
  stage: prep
  script:
    - npm ci --ignore-scripts
    - npm run ci:prep
  cache:
    key: $CI_COMMIT_REF_SLUG-$CI_PROJECT_DIR
    paths:
      - .npm
      - assets/lzwolf/exploded
      - node_modules
      - src/grammar/parsers
    policy: push
  only:
    changes:
      - package-lock.json
      - assets/lzwolf/lzwolf.pk3
      - src/grammar/*.ne

test:
  stage: test
  cache:
    key: $CI_COMMIT_REF_SLUG-$CI_PROJECT_DIR
    paths:
      - .npm
      - node_modules
    policy: pull
  script: npm run ci:test
  coverage: /All files[^|]*\|[^|]*\s+([\d\.]+)/
  artifacts:
    paths:
      - coverage/

build:
  stage: build
  cache:
    key: $CI_COMMIT_REF_SLUG-$CI_PROJECT_DIR
    paths:
      - .npm
      - node_modules
    policy: pull
  script: npm run ci:build
  artifacts:
    paths:
      - dist/

pages:
  stage: build
  script: echo 'Deploying pages...'
  artifacts:
    paths:
      - public
  only:
    - master
